{
  Perhaps it would be good to sort units?
  See this methods (TVirtualDrawTree):
  Sort
  SortTree
  OnCompareNodes

}
unit DisableUnitsFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, VirtualTrees, StdCtrls, Buttons;

type
  TDisableUnitsForm = class(TForm)
    Button1: TButton;
    VDTUnits: TVirtualDrawTree;
    Button2: TButton;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    procedure VDTUnitsInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure VDTUnitsDrawNode(Sender: TBaseVirtualTree;
      const PaintInfo: TVTPaintInfo);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DisableUnitsForm: TDisableUnitsForm;

implementation

uses
  Utility;

{$R *.dfm}

procedure TDisableUnitsForm.VDTUnitsInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);
begin
  Node.CheckType := ctCheckBox;
  Node.Dummy := 0; // we use dummy to store selection status. See VirtualTreeView's docs on what Dummy actually is
end;

procedure TDisableUnitsForm.VDTUnitsDrawNode(Sender: TBaseVirtualTree;
  const PaintInfo: TVTPaintInfo);
var
  s: WideString;
  R: TRect;

begin
  with Sender as TVirtualDrawTree, PaintInfo do
  begin

    if (Node = FocusedNode) and Focused then
      Canvas.Font.Color := clHighlightText
    else
      Canvas.Font.Color := clWindowText;

    R := ContentRect;
    InflateRect(R, -TextMargin, 0);
    Dec(R.Right);
    Dec(R.Bottom);
    s := '';

    case Column of
      0: ; // enabled
      1: s := UnitNames[Node.Index]; // unit name
      2: s := UnitList[Node.Index]; // unit "code name"
    end; // case

    if Length(s) > 0 then
    begin
       with R do
         if (NodeWidth - 2 * Margin) > (Right - Left) then
           s := ShortenString(Canvas.Handle, s, Right - Left, False);
       DrawTextW(Canvas.Handle, PWideChar(S), Length(S), R, DT_TOP or DT_LEFT or DT_VCENTER or DT_SINGLELINE, False);
 //     Canvas.TextOut(ContentRect.Left, ContentRect.Top, s);
    end;
  end;

end;

procedure TDisableUnitsForm.Button1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TDisableUnitsForm.Button2Click(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TDisableUnitsForm.SpeedButton1Click(Sender: TObject);
var
  i: Integer;
begin
  // the simplest way to clear all checkboxes is to clear all nodes :)

  i := VDTUnits.RootNodeCount;
  VDTUnits.RootNodeCount := 0;
  VDTUnits.RootNodeCount := i;
end;

end.
